;------------   Exemple d'application avec un PIC : Un compteur binaire    ---------------
; Titre : Compteur binaire
; Date : 01 Mars 2010
; Auteur : P.M
; PIC utilis : PIC 16 F 88
; On ralise un compteur binaire sur les broches RB0  RB7 d' un PIC 16 F 628 le quartz utilis 
; est de 4 Mhz , on effectue une tempo environ gale  0.2 seconde.

;------------   Directive d' assemblage pour MPLAB   ---------------
	list	p=16f88
	#include p16f88.inc
    errorlevel -302

;------------   Dfinition des constantes   ---------------
#define inter0 0	   ; bouton marche

;------------   Dfinition des registres temporaires   ---------------
retard1      EQU        0x20      ; le registre temporaire retard1 se trouve  l' adresse 20
retard2      EQU        0x21      ; le registre temporaire retard2 se trouve  l' adresse 21
memo         EQU        0x22      ; le registre memo tampon se trouve  l' adresse 22

;------------   Init des ports A et B   ---------------
	ORG 0

	bsf STATUS,5                       ; on met  1 le 5eme bit du registre status pour accder
                                         ;  la 2eme page mmoire ( pour trisa et trisb )
  	MOVLW 0x07                         ; on met 07 dans le registre W
      MOVWF CMCON                        ; on met 07 dans le registre CMCON les comparateurs sont 
      clrf ANSEL				     ; inhibition des entres analogiques

	MOVLW B'00000000'     	; on met 00 dans le registre W
	MOVWF TRISB           	; on met 00 dans le port B il est programm en sortie
	MOVLW 0x1F            	; on met 1F dans le registre W
	MOVWF TRISA           	; on met 00 dans le port A il est programm en entre
	bcf STATUS,5                      ; on remet  0 le 5eme bit du registre status pour accder
	                                          ;  la 1ere page mmoire

;------------   Programme principal   ---------------
Main

        btfss PORTA,inter0       ; interrupteur 0 ( marche ) appuy ? si oui on continu sinon 
        goto Main		; on va  l' tiquette Main

         MOVLW  0xFF            ; on met 255 dans le registre W
         MOVWF  retard1         ; on charge retard1 avec 255 ( FFh contenu du registre W )
         MOVLW  0xFF            ; on met 255 dans le registre W
         MOVWF  retard2         ; on charge retard2 avec 255 ( FFh contenu du registre W )
         MOVF  memo, W         ; on met memo dans W
         MOVWF  PORTB         ; on met W sur le port B ( leds )
         CALL  tempo               ; on appel la temporisation
         MOVLW  0x01             ; on met 1 dans le registre W
         ADDWF  memo, F        ; on additionne memo + 1
         GOTO  Main                 ; retour au dbut du programme

;------------   Programme de temporisation ( 0.2 s )   ---------------

tempo
          DECFSZ retard1,F        ; on dcrmente retard1 et on saute la prochaine instruction si 
          GOTO  tempo              ; le registre retard1 = 0 sinon retour  tempo
          MOVLW 0xFF             ; on met 255 dans le registre W
          MOVWF retard1          ; on charge retard1 avec 255 ( FFh contenu du registre W )
          DECFSZ retard2,F       ; on dcrmente retard1 et on saute la prochaine instruction si 
          GOTO  tempo              ; le registre retard1 = 0 sinon retour  tempo
          RETURN                     ; retour au programme principal aprs l 'instruction CALL

          END                            ; fin du programme
